package uk.me.nxg.unity;

import java.util.List;

class UnitVal {
    private final static int INVALID = 0;
    private final static int INTEGER = 1;
    private final static int STRING = 2;
    private final static int CHAR = 3;
    private final static int UNIT = 4;
    private final static int UNITLIST = 5;
    private final static int FLOAT = 6;

    final static char CHAR_DECA = (char)1;

    private int type;
    /**
     * The following have to be public, for the sake of the generated Parser.java
     */
    public int i;
    public double f;
    public String s;
    public char c;
    public OneUnit u;
    public List<OneUnit> uList;
    public UnitVal() {          // parser includes a call to new UnitVal()
        type = INVALID;
    }
    public UnitVal(int v)        { i=v; type=INTEGER; }
    public UnitVal(String v)     { s=v; type=STRING;  }
    public UnitVal(char v)       { c=v; type=CHAR;    }
    public UnitVal(OneUnit v)    { u=v; type=UNIT;    }
    public UnitVal(double v)     { f=v; type=FLOAT;   }
    
    public String toString() {
        String rval;
        switch (type) {
          case INTEGER:  rval = Integer.toString(i);   break;
          case STRING:   rval = s;                     break;
          case CHAR:     rval = Character.toString(c); break;
          case UNIT:     rval = u.toString();          break;
          case FLOAT:    rval = Double.toString(f);    break;
          case UNITLIST:
              {
                  StringBuilder sb = new StringBuilder();
                  for (OneUnit oneUnit : uList) {
                      sb.append(u.toString()).append(' ');
                  }
                  rval = sb.toString();
              }
              break;
          default:
            throw new AssertionError("Impossible UnitVal case: " + type);
        }
        return rval;
    }
    // @override
    // public Object clone() throws CloneNotSupportedException {
    //     UnitVal result = (UnitVal)super.clone();
    //     result.type = type;
    //     result.i = i;
    //     result.s = s;
    //     result.c = c;
    //     result.u = u;
    //     result.uList = uList;
    //     return result;
    // }
}
