package uk.me.nxg.unity;

class UnitWriterFits extends UnitWriter {

    public UnitWriterFits(UnitExpr ue) {
        super(ue);
    }

    public String write() {
        StringBuilder sb = new StringBuilder();
        boolean first = true;
        if (ue.getLogFactor() != 0.0) {
            sb.append("10^");
            writeNumber(sb, ue.getLogFactor());
            first = false;
        }
        for (OneUnit u : ue.asList()) {
            // FIXME: should I reorder the units to get all of the negative powers to the end?
            if (first) {
                first = false;
            } else {
                sb.append(' ');
            }
            sb.append(u.unitString(UnitParser.FITS));
            double e = u.getExponent();
            if (e != 1.0) {
                writeNumber(sb, e);
            }
        }
        return sb.toString();
    }

    void writeNumber(StringBuilder sb, double d) {
        writeNumber(sb, d, true, false);
    }
}
